@echo off
chcp 65001 > nul
echo ╔═══════════════════════════════════════════════════════════════════════════════════════════╗
echo ║ https://profit-zip.ru/blog/windows/soedinenie-s-setyu-anydesk-otklyuchen-ot-seti-anydesk/ ║
echo ╚═══════════════════════════════════════════════════════════════════════════════════════════╝
set BACKUP = n

net session >nul 2>&1
if %errorLevel% == 0 (
echo.
) else (
echo Скрипт запущен НЕ от имени администратора. Запустите этот файл от имени администратора.
goto end
)

echo Проверка доступа в Интернет ...

set dnscacheisempty=no

:pings

set /A errors = 0
set /A dnserrors = 0

ping -n 4 8.8.8.8 >nul
if %errorlevel% equ 0 (
echo Пинг до Google DNS: успешно.
) else (
echo Пинг до Google DNS: ошибка.
set /A errors = %errors% + 1
)

ping -n 4 77.88.8.8 >nul
if %errorlevel% equ 0 (
echo Пинг до Yandex DNS: успешно.
) else (
echo Пинг до Yandex DNS: ошибка.
set /A errors = %errors% + 1
)

ping -n 4 google.com >nul
if %errorlevel% equ 0 (
echo Пинг до Google:     успешно.
) else (
echo Пинг до Google:     ошибка.
set /A errors = %errors% + 1
set /A dnserrors = %dnserrors% + 1
)

ping -n 4 yandex.ru >nul
if %errorlevel% equ 0 (
echo Пинг до Yandex:     успешно.
) else (
echo Пинг до Yandex:     ошибка.
set /A errors = %errors% + 1
set /A dnserrors = %dnserrors% + 1
)

if %dnserrors% neq 0 (
if %errors% neq 4 (
if %dnscacheisempty%==no (
echo Есть проблемы с доступом к именам доменов. Очистка кэша DNS ...
ipconfig /flushdns > nul
set dnscacheisempty=yes
echo Повторный пинг ...
echo.
goto pings
)
)
)

if /i %errors% equ 4 (
ping -n 4 127.0.0.1 >nul
if %errorlevel% equ 0 (
echo Пинг localhost:     успешно.
echo.
echo Вероятно у Вас проблема с доступом к глобальной сети.
) else (
echo Пинг localhost:     ошибка.
echo.
echo Вероятно у Вас проблема с сетевым адаптером или Вы не подключены к сети.
echo Проверьте подключение к Wi-Fi или подключение LAN-кабеля к компьютеру.
goto end
)
)
echo.

echo Проверка доступа к сети AnyDesk ...

ping -n 4 boot.net.anydesk.com >nul
if %errorlevel% equ 0 (
echo Пинг до AnyNet:     успешно.
) else (
echo Пинг до AnyNet:     ошибка.
echo.
if %dnserrors% equ 0 (
echo Возможно доступ к сети AnyDesk блокирует межсетевой экран или провайдер, либо
echo у самих серверов AnyDesk некоторые проблемы...
) else (
echo Невозможно получить доступ к серверу AnyNet и другим. Похоже, у вас проблемы с
echo DNS-сервером или установлены строгие правила межсетевого экрана.
)
goto end
)
echo.

echo Установите верные дату, время и часовой пояс в открывшемся окне.
echo В вкладке "Время по Интернету" - "Изменить параметры" установите галочку "Синхронизировать"
echo и нажмите "Обновить сейчас" 5-7 раз.
echo.
echo После установки верных параметров, нажмите на это окно и нажмите любую клавишу на клавиатуре.
echo Ожидание нажатия клавиши ...
timeout /t 3 > nul
timedate.cpl
pause >nul
echo.

if exist "%appdata%\AnyDesk\user.conf" (
if exist "%systemdrive%\ProgramData\AnyDesk\service.conf" (
goto askbackup
)
)
goto noaskbackup

:askbackup
echo === Выполнить копирование пользовательских данных? ===
echo Это позволит сохранить текущий ID, пароль для входа на этот компьютер, сохраненные пароли
echo для подключения к другим компьютерам, список последних подключений.
SET /P BACKUP=Введите Y для копирования, любой другой символ (или Enter), если копирование не требуется: 
echo.

:noaskbackup
IF /I "%BACKUP%" EQU "Y" (
set /a errors = 0
echo Резервное копирование пользовательских настроек ...
copy "%appdata%\AnyDesk\user.conf" "%temp%\ADuser.conf" > nul
set /a errors = %errors% + %errorlevel%
copy "%systemdrive%\ProgramData\AnyDesk\service.conf" "%temp%\ADservice.conf" > nul
set /a errors = %errors% + %errorlevel%
if %errors% neq 0 (
echo Пользовательские данные не найдены
)
echo.
)

taskkill /f /im "AnyDesk.exe" >nul 2>&1
if %errorLevel% == 0 (
echo Завершение процесса AnyDesk: успех.
) else (
if %errorLevel% == 128 (
echo Завершение процесса AnyDesk: процесс не запущен.
) else (
echo Завершение процесса AnyDesk: нет доступа. Попробуйте перезагрузить компьютер.
goto end
)
)

rd /S /Q "C:\ProgramData\AnyDesk" >nul 2>&1 || rem
if %errorLevel% == 0 (
echo Удаление папки из ProgramData: успех.
) else (
if %errorlevel% == 2 (
echo Удаление папки из ProgramData: папка не найдена.
) else (
echo Удаление папки из ProgramData: нет доступа.
goto end
)
)

rd /S /Q "%appdata%\AnyDesk" >nul 2>&1 || rem
if %errorLevel% == 0 (
echo Удаление папки из AppData: успех.
) else (
if %errorlevel% == 2 (
echo Удаление папки из AppData: папка не найдена.
) else (
echo Удаление папки из AppData: нет доступа.
goto end
)
)

echo.
echo Загрузка AnyDesk 7.0.14.0 ...
curl -Isf "https://profit-zip.ru/eniweb/AnyDesk-7.0.14.0.exe" | find "200 OK" > nul
if %errorlevel% equ 0 (
curl "https://profit-zip.ru/eniweb/AnyDesk-7.0.14.0.exe" --output "%temp%\anydesk.exe" >nul 2>&1
goto install
) else (
echo Файл не найден на сервере Profit-zip.ru
echo.
)

echo Попытка скачать свежую версию AnyDesk с официального сайта ...
echo.
curl -Isf "https://download.anydesk.com/AnyDesk.exe" | find "200 OK" > nul
if %errorlevel% equ 0 (
curl "https://download.anydesk.com/AnyDesk.exe" --output "%temp%\anydesk.exe" >nul 2>&1
) else (
echo Невозможно загрузить программу с официального сайта. Попробуйте скачать и установить AnyDesk вручную.
if exist "%programfiles(x86)%\AnyDesk" (cd "%programfiles(x86)%\AnyDesk")
if exist AnyDesk.exe (
echo Сейчас удалим старую версию AnyDesk и откроем ссылочку для скачивания новой.
AnyDesk.exe --remove
) else (
if exist "%programfiles%\AnyDesk" (cd "%programfiles%\AnyDesk")
if exist AnyDesk.exe (
echo Сейчас удалим старую версию AnyDesk и откроем ссылочку для скачивания новой.
AnyDesk.exe --remove
) else (
echo Сейчас откроем ссылочку для скачивания AnyDesk.
)
)
timeout /t 5 > nul
start https://download.anydesk.com/AnyDesk.exe
goto end
)

:install
echo Установка AnyDesk ...
cd %temp%
anydesk.exe --install "%programfiles%\AnyDesk" --start-with-win --create-shortcuts --create-desktop-icon --remove-first --update-disabled
echo AnyDesk установлен.
echo.

IF /I "%BACKUP%" EQU "Y" (
echo Восстановление пользовательских настроек ...
taskkill /f /im "AnyDesk.exe" > nul
copy /Y "%temp%\ADuser.conf" "%appdata%\AnyDesk\user.conf" > nul
copy /Y "%temp%\ADservice.conf" "%systemdrive%\ProgramData\AnyDesk\service.conf" > nul
)

echo Удаление временных файлов ...
del "%temp%\anydesk.exe" > nul
IF /I "%BACKUP%" EQU "Y" (
del "%temp%\ADuser.conf" > nul
del "%temp%\ADservice.conf" > nul
)
echo.

IF /I "%BACKUP%" EQU "Y" (
echo Запустите AnyDesk.
) else (
echo Запуск AnyDesk.
)
echo Первое подключение к сети AnyDesk может занять около двух минут.
echo.
echo Если подключение к сети так и не удалось, запустите этот файл вновь, но не сохраняйте
echo пользовательские данные.

:end
echo =========================================================================================
echo Нажмите любую кнопку для выхода.
pause >nul